#!/usr/bin/perl -w
# dansguardian-lib.pl

do '../web-lib.pl';
&init_config();
%access = &get_module_acl();
$pidfilepath = "$config{'pid_file'}";

# Get the DG version
$dg_version=checkdgver();

# Get the AVPlugin version, if any
if (open(AVPLUGINVERSION, "$module_config_directory/avpluginversion")) {
  chop($avplugin_version = <AVPLUGINVERSION>);
  close(AVPLUGINVERSION);
}

# Read in the dansguardian.conf file
$cfref = read_file_lines($config{'conf_file'});
$avcfref = read_file_lines($avconffilepath);
$modulever = "0.5.10-pr5";

## checkdgconf();
## Check for existance of DG config file
sub checkdgconf {
  $conffilepath = "$config{'conf_file'}";
  if (!(-f $conffilepath)) {
    print "<p>";
    print &text('error_confnotfound', $conffilepath, "/config.cgi?$module_name"),"<p>\n";
    print "$text{'index_confloc'} $conffilepath.";
    print "<hr>\n";
    &footer("/", $text{'index_return'});
#    exit;
  } else {
    return true;
  }
}

## checkdgbinary();
## Check for existance and executable state of DG binary
sub checkdgbinary {
  if (!(-x $config{'binary_file'})) {
    print "<p>";
    print &text('error_binnotfound', $config{'binary_file'}, "/config.cgi?$module_name"),"<p>\n";
    print "<hr>\n";
    &footer("/", $text{'index_return'});
#    exit;
  } else {
    return true;
  }
}

## checkdgver();
## Check DG version for compatibility
sub checkdgver {
  my $ver = `$config{'binary_file'} -v 2>&1`;
  if ($ver =~ /(2\.4\.\d+-?(\d+)?)/ || $ver =~ /(2\.5\.\d+-?(\d+)?)/ || $ver =~ /(2\.6\.\d+-?(\d+)?) / || $ver =~ /(2\.7\.\d+-?(\d+)?)/ || $ver =~ /(2\.8\.\d+-?(\d+)?)/) {
    return $1;
  } else {
    return false;
  }
}

## checkmodauth(ACLNAME);
## Check webmin ACL's for ACLNAME against username
sub checkmodauth {
  my $section = $_[0];
  if (!$access{$section}) {
    print "<p>$text{'index_notauth'}\n";
    &footer("index.cgi", $text{'index_return'});
    exit;
  }
}

sub readconfigoption {
    my $option = $_[0];
    my $value;
    my $name;
    my $line;
    foreach $line (@$cfref) {
        ($name, $value) = split(/=/, $line);
        $name =~ s/ //g;
        if ($name eq $option) {
            $value =~ s/ //g;
            $value =~ s/^'//g;
            $value =~ s/'.*$//g;
            return $value;
        }
    }
}

## Read filter group config. This is so ugly
sub readgroupconf {
  my $group = $_[0];
  my $option = $_[1];
  my $value;
  my $name;
  my $line;
  my $cfrefgrp = read_file_lines($config{'conf_path'} . "/dansguardian" . $group . ".conf");
  foreach $line (@$cfrefgrp) {
    ($name, $value) = split(/=/, $line);
    $name =~ s/ //g;
    if ($name eq $option) {
      $value =~ s/ //g;
      $value =~ s/^'//g;
      $value =~ s/'.*$//g;
      return $value;
    }
  }
}

sub readavconfigoption {
    my $option = $_[0];
    my %configmappings = ("avpluginquarantinedir" => "Quarantine Dir","avplugindownloaddir" => "Download Dir","avpluginlogfacility" => "Log Facility","avpluginvirusscanner" => "Virus Scanner","avpluginsweep" => "Sweep","avpluginvirusscannertimeout" => "Virus Scanner Timeout","avpluginlocalpostmaster" => "Local Postmaster","avpluginmaildomain" => "Mail Domain", "avpluginmailserver" => "Mail Server", "avpluginmailtype" => "Mail Type","avpluginaction" => "Action","avplugindebug" => "Debug","avpluginlockfiledir" => "Lock File Dir","avpluginminimumcodestatus" => "Minimum Code Status");
    my $value;
    my $name;
    my $line;
    foreach $line (@$avcfref) {
        ($name, $value) = split(/=/, $line);
        $name =~ s/^\s*//g;
	$name =~ s/\s*$//g;
        if ($name =~ /^$configmappings{$option}$/i) {
            $value =~ s/^\s*//g;
	    $value =~ s/\#.*$//g;
	    $value =~ s/\s*$//g;
            return $value;
        }
    }
}

# form_line(<configfileoptionname>, <icon size>, <icon max len>, <editable file>)
sub form_line {
    my $option = $_[0];
    my $size = $_[1];
    my $maxlen = $_[2];
    my $helpfile = $_[3];
    my $editable = $_[4];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr>", "<td>", &hlink("$label", "$helpfile"), "</td>", "<td><input name=$option size=$size maxlength=$maxlen value=\'$value\'>";
    if ($editable ne "") {
        print " <A HREF=\"./edit.cgi?file=$value\">$editable</a>";
    }
    print "</td></tr>\n";
}

# av_form_line(<configfileoptionname>, <icon size>, <icon max len>, <editable file>)
sub av_form_line {
    my $option = $_[0];
    my $size = $_[1];
    my $maxlen = $_[2];
    my $helpfile = $_[3];
    my $editable = $_[4];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readavconfigoption($option);
    print "<tr>", "<td>", &hlink("$label", "$helpfile"), "</td>", "<td><input name=$option size=$size maxlength=$maxlen value=$value>";
    if ($editable ne "") {
        print " <A HREF=\"./edit.cgi?file=$value\">$editable</a>";
    }
    print "</td></tr>\n";
}

# edit_line_file(<configfileoptionname>, <icon size>, <icon max len>, <editable file>)
sub edit_line_file {
    my $option = $_[0];
    my $helpfile = $_[1];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr>", "<td>", &hlink("$label", "$helpfile"), "</td>", "<td>$value</td>", "<td><A HREF=\"./edit.cgi?file=$value\">$text{'index_edit'}</a></td></tr>\n";
    # search the file for '.Include<...>' directives and list any files found
    $fileref = read_file_lines($value);
    my $file_line;
    my $file_count = 0;
    my $output_string = "";

    foreach $file_line (@{$fileref}) {
        if ($file_line =~ /^\s*\.Include\<([^\>]+)\>.*$/) {
	    if ($file_count != 0) {
	        $output_string .= "<tr>";
	    }
            $output_string .= "<td>$1</td><td><A HREF=\"./edit.cgi?file=$1\">$text{'index_edit'}</A></td></tr>\n";
	    $file_count++;
	}
    }
    if ($output_string ne "") {
        print "<tr><td rowspan=\"$file_count\">&nbsp;</td>$output_string</tr>\n";
    }
}

# form_option(<configfileoptionname>)
sub form_option {
    my $option = $_[0];
    my $helpfile = $_[1];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td>", "<td><input type=checkbox name=$option value=\"on\"";
    if ($value eq 'on') {
        print 'CHECKED';
    }
    print "></td></tr>\n";
}

# form_radio(<configfileoptionname>, <option 1>, <option 2>, ...)
sub form_radio {
    my @options = @_;
    my $option = $options[0];
    my $optionconf = "conf_$option";
    my $optionradio = $optionconf . "_radio_";
    my $label = $text{$optionconf};
    my $helpfile = $options[0];
    my $value = readconfigoption($option);
    my $radio = "blah";
    my $radioname;
    my $i = 1;
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td><td>";
    while($radio ne "") {
        $radio = $options[$i];
        if (length($radio) > 0) {
            print "<INPUT TYPE=RADIO NAME=\"$option\" VALUE=\"$radio\"";
            if ($radio eq $value) {
                print " CHECKED";
            }
            $radioname = $optionradio . "$i";
            print "> $radio = $text{$radioname}<BR>";
        }
        $i++;
    }
    print "</td></tr>\n";
}

# av_form_radio(<configfileoptionname>, <option 1>, <option 2>, ...)
sub av_form_radio {
    my @options = @_;
    my $option = $options[0];
    my $optionconf = "conf_$option";
    my $optionradio = $optionconf . "_radio_";
    my $label = $text{$optionconf};
    my $helpfile = $options[0];
    my $value = readavconfigoption($option);
    my $radio = "blah";
    my $radioname;
    my $i = 1;
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td><td>";
    while($radio ne "") {
        $radio = $options[$i];
        if (length($radio) > 0) {
            print "<INPUT TYPE=RADIO NAME=\"$option\" VALUE=\"$radio\"";
            if ($radio eq $value) {
                print " CHECKED";
            }
            $radioname = $optionradio . "$i";
            print "> $radio = $text{$radioname}<BR>";
        }
        $i++;
    }
    print "</td></tr>\n";
}

sub form_file {
    my $option = $_[0];
    my $fileref = read_file_lines($option);
    my $line;
    print "<INPUT TYPE=HIDDEN NAME=\"filename\" VALUE=\"$option\">";
    print "<TEXTAREA NAME=\"filecontents\" ROWS=30 COLS=80>";
    foreach $line (@$fileref) {
        print &html_escape($line)."\n";
    }
    print "</TEXTAREA>";
}

# restart_button()
# Returns HTML for a link to put in the top-right corner
# I stole this from the apache module
sub restart_button {
  my $pidfile = "$pidfilepath";
  if ($access{'start'}) {
    if (open(PID, $pidfile) && <PID> =~ /(\d+)/ && kill(0, $1)) {
        close(PID);
        $rv = "<a href=\"status.cgi?action=restart\">$text{'header_restartdg'}</a><br>\n";
        if ($dg_version ge "2.7.5") {
          $rv .= "<a href=\"status.cgi?action=regroup\">$text{'header_regroup'}</a><br>\n";
        }
        $rv .= "<a href=\"status.cgi?action=stop\">$text{'header_stopdg'}</a>\n";
    }
    else {
        $rv = "<a href=\"status.cgi?action=start\">$text{'header_startdg'}</a><br>\n";
    }
    return $rv;
  }
}

sub dgprocess {
  my $action = $_[0];
  if ($access{$action}) {
  # You are authorized to perform the action
    if ($action eq "start") {
      if ($config{'start_cmd'}) {;
        $cmd = "$config{'start_cmd'}";
      } else {
        $cmd = "$config{'binary_file'}";
      }
    } elsif ($action eq "stop") {
      if ($config{'stop_cmd'}) {
        $cmd = "$config{'stop_cmd'}";
      } else {
        $cmd = "pkill dansguardian";
      }
    } elsif ($action eq "restart") {
      if ($config{'restart_cmd'}) {
        $cmd = "$config{'restart_cmd'}";
      } elsif (($config{'restart_type'} eq "1") && ($dg_version ge "2.7.5")) {
          $cmd = "$config{'binary_file'} -r";
      } else {
          $cmd = "pkill dansguardian\; sleep 3\; $config{'binary_file'}";
      }
    } elsif (($action eq "regroup") && ($dg_version ge "2.7.5")) {
      $cmd = "$config{'binary_file'} -g";
    } elsif ($action eq "status") {
      $cmd = "$config{'binary_file'} -s";
    }
  } else {
  # You are not authorized to perform the action
    print "<p>$text{'index_notauth'}\n";
    &footer("index.cgi", $text{'index_return'});
    exit;
  }
  # Now we run the command, and display output
  $temp = &tempname();
  $rv = &system_logged("$cmd >$temp 2>&1 </dev/null");
  $out = `cat $temp`;
  unlink($temp);
  &reset_environment();
  print "<center><font size=+2>$cmd</font></center>\n";
  print "<hr>\n";
  print "<p>",&text('run_out', "<tt>".&html_escape($displaystr)."</tt>"),"\n";
  print "<pre>";
  if ($out) { print $out; } else { print "$text{'index_done'}" };
  print "</pre>\n";
  print "<hr>\n";
}
