#!/usr/bin/perl
# editconf.cgi

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();
&header($text{'edit_dgconfig'}, "");
%access = &get_module_acl();

# Make sure user has access to this file
&checkmodauth(editconf);

# Check if DansGuardian conf file is there
&checkdgconf;

$configsection = $in{"section"};
if ($configsection eq "") { $configsection = "network" }

print "$text{'index_dgversion'} $dg_version<br>\n";
if ($avplugin_version ne "") {
  print "$text{'index_avpluginversion'} $avplugin_version<br>\n";
}
print "<p align=left>$text{'index_clickhelp'}</p>";

## Links for different sections
print "<p align=left><a href=\"?section=network\">Network</a>";
print " <a href=\"?section=process\">Process</a>";
print " <a href=\"?section=logging\">Logging</a>";
print " <a href=\"?section=content\">Content Filter</a>";
print " <a href=\"?section=misc\">Misc</a>";
print "</p>";

print "<form action=saveconf.cgi method=post>\n";
$cfref = read_file_lines($conffilepath);
print "<INPUT TYPE=HIDDEN NAME=\"conffilepath\" VALUE=\"$conffilepath\">";
print "<input type=hidden name=\"configsection\" value=\"$configsection\">";
print "<table border=1 width=100% cellspacing=1 cellpadding=1>\n";

##
## This begins the configuration sections
## Each section is accessed by the section= variable
## in the URL.
## The saveconf.cgi also obeys the same section groupings
##
## Begin network section
if ($configsection eq "network") {
  &form_line("filterip", 15, 15, "filterip");
  print "<p>";
  &form_line("filterport", 4, 5, "filterport");
  print "<p>";
  &form_line("proxyip", 15, 15, "proxyip");
  print "<p>";
  &form_line("proxyport", 4, 5, "proxyport");
  print "<p>";
  &form_option("reverseaddresslookups", "reverseaddresslookups");
  print "<p>";
  &form_option("usernameidmethodproxyauth", "usernameauth");
  print "<p>";
  &form_option("usernameidmethodident", "usernameauth");
  print "<p>";
  &form_option("forwardedfor", "forwardedfor");
  print "<p>";

  ## Version Specific options
  if ($dg_version ge "2.4.6") {
    &form_option("usexforwardedfor", "usexforwardedfor");
    print "<p>";
  }
  if ($dg_version ge "2.7.5") {
    &form_option("reverseclientiplookups", "reverseclientiplookups");
    print "<p>";
  }
## End  network section
} elsif ($configsection eq "process") {

## Begin process section
  print "<b>Process Options</b><p>\n";
  print "<table border=1 width=100% cellspacing=1 cellpadding=1>\n";

  &form_line("maxchildren", 3, 4, "maxchildren");
  print "<p>";
                                                                                
  if ($dg_version ge "2.7.0") {
    &form_line("minchildren", 3, 3, "minchildren");
    print "<p>";
    &form_line("minsparechildren", 3, 3, "minsparechildren");
    print "<p>";
    &form_line("preforkchildren", 3, 3, "preforkchildren");
    print "<p>";
    &form_line("maxsparechildren", 3, 3, "maxsparechildren");
    print "<p>";
    &form_line("maxagechildren", 6, 6, "maxagechildren");
    print "<p>";
  }
  if ($dg_version ge "2.7.2") {
      &form_line("ipcfilename", 56, 128, "ipcfilename");
      print "<p>";
      &form_line("urlipcfilename", 56, 128, "urlipcfilename");
      print "<p>";
      &form_line("pidfilename", 56, 128, "pidfilename");
      print "<p>";
      &form_option("nodaemon", "nodaemon");
      print "<p>";
      &form_option("nologger", "nologger");
      print "<p>";
      &form_line("daemonuser", 20, 128, "daemonuser");
      print "<p>";
      &form_line("daemongroup", 20, 128, "daemongroup");
      print "<p>";
      &form_option("softrestart", "softrestart");
      print "<p>";
  }
## End process section
} elsif ($configsection eq "logging") {

## Begin logging section
  &form_option("logexceptionhits", "logexception");
  print "<p>";
  &form_option("showweightedfound", "showweighted");
  print "<p>";
  &form_radio("reportinglevel","-1","0","1","2","3");
  print "<p>";
  &form_option("logconnectionhandlingerrors", "logconnecterr");
  print "<p>";
  if ($dg_version ge "2.4.2") {
    &form_radio("loglevel","0","1","2","3");
    print "<p>";
  }
  if ($dg_version ge "2.5.3") {
    &form_radio("logfileformat","1","2","3","4");
  } else {
    &form_radio("logfileformat","1","2");
  }
## End logging section
} elsif ($configsection eq "content") {

## Begin content section
  my @filepaths = ('banneduserlist', 'bannediplist', 'exceptionuserlist', 'exceptioniplist');
  if (($dg_version ge "2.5.3") && ($dg_version lt "2.7.5")) {
    push(@filepaths, 'contentregexplist');
  }
  if ($dg_version lt "2.7.5") {
    push(@filepaths, 'bannedphraselist', 'bannedextensionlist', 'bannedmimetypelist', 'bannedsitelist', 'bannedurllist', 'bannedregexpurllist', 'exceptionphraselist', 'exceptionsitelist', 'exceptionurllist', 'weightedphraselist', 'picsfile');
  }
                                                                                
  foreach (@filepaths) {
    &form_line("$_", 56, 128, "filepaths");
    print "<p>";
  }
                                                                                
  &form_line("maxuploadsize", 4, 6, "post");
  print "<p>";
                                                                                
  if ($dg_version ge "2.4.3") {
    &form_radio("weightedphrasemode","0","1","2");
    print "<p>";
  }
  if ($dg_version lt "2.7.5") {
    &form_line("naughtynesslimit", 3, 3, "naughtyness");
    print "<p>";
  }
  if ($dg_version ge "2.5.3") {
    &form_line("urlcachenumber", 4, 4, "urlcachenumber");
    print "<p>";
    &form_line("urlcacheage", 4, 4, "urlcacheage");
    print "<p>";
    &form_line("maxcontentfiltersize", 6, 6, "maxcontentfiltersize");
    print "<p>";
  }
  if ($dg_version ge "2.7.0") {
    &form_radio("phrasefiltermode","0","1","2");
    print "<p>";
    &form_option("preservecase", "preservecase");
    print "<p>";
    &form_option("hexdecodecontent", "hexdecodecontent");
    print "<p>";
    &form_option("forcequicksearch", "forcequicksearch");
    print "<p>";
  }
  if ($dg_version ge "2.7.5") {
    &form_option("nonstandarddelimiter", "nonstandarddelimiter");
    print "<p>";
    &form_option("preemptivebanning", "preemptivebanning");
    print "<p>";
    &form_line("filtergroups", 3, 3, "filtergroups");
    print "<p>";
    &form_line("filtergroupslist", 56, 128, "filtergroupslist");
    print "<p>";
  }
## End content section
} elsif ($configsection eq "misc") {

## Begin misc section
  &form_option("createlistcachefiles", "createlistcache");
  print "<p>";
  &form_line("accessdeniedaddress", 56, 128, "accessdeniedaddress");
  print "<p>";
  if ($dg_version lt "2.7.0") {
        &form_line("htmltemplate", 56, 128, "htmltemplate");
        print '<P>';
  }
  if (($dg_version ge "2.5.3") && ($dg_version lt "2.7.5")) {
    &form_line("languagefile", 56, 128, "filepaths");
    print "<p>";
  }
  if ($dg_version ge "2.7.0") {
    &form_line("languagedir", 56, 128, "languagedir");
    print "<p>";
    &form_line("language", 25, 50, "language");
    print "<p>";
  }
## End misc section
} elsif ($configsection eq "antivirus") {

## Begin antivirus section
  if (($dg_version ge "2.4.5-2") && ($avplugin_version ge "1.0")) {
    &form_option("virusscan", "virusscan");
    print "<p>";
    if ($avplugin_version ge "1.0" and $avplugin_version !~ /1.0rc/) {
      &form_line("exceptionvirusmimetypelist", 56, 128, "exceptionvirusmimetype");    print "<p>";
      &form_line("exceptionvirusextensionlist", 56, 128, "exceptionvirusextension");
    }
  }
## End antivirus section
}
## End of Section Groupings

print "</table>";
print "<p>";
## End of Config options

print "<p><input type=submit value=\"$text{'save'}\"></form>\n";
print "<hr>\n";
&footer("index.cgi", $text{'index_return'});
exit;
