#!/usr/bin/perl
# editlists.cgi

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();
&header($text{'edit_blacklists'}, "");
%access = &get_module_acl();

if (!$access{'editlists'}) {
  print "<p>$text{'index_notauth'}\n";
  &footer("index.cgi", $text{'index_return'});
  exit;
}

# Check if DansGuardian conf file is there
$conffilepath = "$config{'conf_file'}";
if (!(-f $conffilepath)) {
    print "<p>";
    print &text('error_confnotfound', $conffilepath, "/config.cgi?$module_name"),"<p>\n";
    print "$text{'index_confloc'} $conffilepath.";
    print "<hr>\n";
    &footer("index.cgi", $text{'index_return'});
    exit;
}
print "$text{'index_dgversion'} $dg_version<br>\n";
if ($avplugin_version ne "") {
  print "$text{'index_avpluginversion'} $avplugin_version<br>\n";
}
#print "<p align=left>$text{'index_clickhelp'}</p>";

$cfref = read_file_lines($conffilepath);
print "<table border=1 width=100% cellspacing=1 cellpadding=1>\n";

## Files for all versions
my @configuration_files = ("banneduserlist", "exceptionuserlist", "bannediplist", "exceptioniplist");

## Less than 2.7.5
if ($dg_version lt "2.7.5") {
  push(@configuration_files, "htmltemplate", "bannedphraselist", "banneduserlist", "bannediplist", "bannedextensionlist", "bannedmimetypelist", "bannedsitelist", "bannedurllist", "bannedregexpurllist", "exceptionphraselist", "exceptionsitelist", "exceptionuserlist", "exceptioniplist", "exceptionurllist", "weightedphraselist", "picsfile");
}

%help_files = ("banneduserlist", "exceptionuserlist", "bannediplist", "exceptioniplist");

if ($dg_version lt "2.7.5") {
  %help_files = ("htmltemplate" => "htmltemplate", "bannedphraselist" => "filepaths", "banneduserlist" => "filepaths", "bannediplist" => "filepaths", "bannedextensionlist" => "filepaths", "bannedmimetypelist" => "filepaths", "bannedsitelist" => "filepaths", "bannedurllist" => "filepaths", "bannedregexpurllist" => "filepaths", "exceptionphraselist" => "filepaths", "exceptionsitelist" => "filepaths", "exceptionuserlist" => "filepaths", "exceptioniplist" => "filepaths", "exceptionurllist" => "filepaths", "weightedphraselist" => "filepaths", "picsfile" => "filepaths");
}
my $conf_file;

if (($dg_version ge "2.5.3") && ($dg_version lt "2.7.5")) {
  push (@configuration_files, 'contentregexplist', 'languagefile');
  $help_files{"contentregexplist"} = "filepaths";
  $help_files{"languagefile"} = "filepaths";
}
if (($dg_version ge "2.4.5-2") && ($avplugin_version ge "1.0" && $avplugin_version !~ /1.0rc/)) {
  push (@configuration_files, 'exceptionvirusmimetypelist', 'exceptionvirusextensionlist');
  $help_files{"exceptionvirusmimetypelist"} = "exceptionvirusmimetype";
  $help_files{"exceptionvirusextensionlist"} = "exceptionvirusextension";
}

foreach $conf_file (@configuration_files) {
  if ($access{$conf_file}) {
    &edit_line_file("$conf_file", $help_files{$conf_file});
  }
}

print "<p align=left>$text{'index_urlsearch_title'}";
print "<p align=left><form action=search2.cgi>\n";
print "<input name=search size=20 maxlength=20 value=\"$text{'index_search'}\">";
print "<P><input type=submit></form>\n";
print '<P>';

print "</table>";
print "<p>\n";
print "<hr>\n";
&footer("index.cgi", $text{'index_return'}, "editlists.cgi", $text{'edit_dgfiles'});
exit;

