#!/usr/bin/perl
# index.cgi

require './dansguardian-lib.pl';
use POSIX;
ReadParse();
%access = get_module_acl();

# Check the version number
$avpluginver = `$config{'binary_file'} -P 2>&1`;

if (checkdgver() eq "false") {
     header($text{'index_title'}, "", undef, 1, 1);
      print "<hr>\n";
      print "<p>$text{'index_notsupported'}<p>";
      print "$text{'index_dgversion'} $dg_version<br>\n";
      print "<hr>\n";
      footer("/", $text{'index_return'});
      exit;
## Binary or conf file does not exist or is not executable, warn the user
} elsif (!(checkdgconf) && (checkdgbinary)) {
  header($text{'index_title'}, "", undef, 1, 1);
  print "<hr>\n";
  print "<p>";
  if (!(checkdgconf)) {
    print "$text{'error_confnotfound'}<br>\n";
    print "$text{'index_confloc'} $config{'conf_file'}<p>\n";
  }
  if (!(checkdgbinary)) {
    print "$text{'error_binnotfound'}<br>\n";
    print "$text{'index_binaryloc'} $config{'binary_file'}<p>\n";
  }
  print "$text{'error_modconfig'}<p>\n";
  print "<hr>\n";
  exit 0;
}

## Now check the AV Plugin version
if ($avpluginver =~ /^AntiVirus\sPlugin\s(\d+\.\d+-?(\w+)?)$/) {
    # Save version number
    open(AVPLUGINVERSION, ">$module_config_directory/avpluginversion");
    print AVPLUGINVERSION $1,"\n";
    close(AVPLUGINVERSION);
    $avplugin_version = $1;
  } else {
    unlink("$module_config_directory/avpluginversion");
}

## Print the Header
&header($text{'index_title'}, "", "index", 1, 1, 0, &restart_button."<br>".
  &help_search_link("dansguardian", "man"), undef, undef, &text('index_version')." ".$dg_version);
  
print "$text{'index_modulever'} $modulever<br>\n";

print "<hr>\n";

# Set the arrays for the links, titles, and icons of each option
# NOTE: The .cgi file names MUST be the same as the title and icon for the 
# button! Or if you put the word edit infront of the filename, i.e. editconf.cgi
# then all will be ok as the edit is stripped later.
# Otherwise problems will occur.
#
@olinks = ( "status.cgi", "logs.cgi", "editconf.cgi", "editfiles.cgi" );
if ($dg_version lt "2.7.5") {
  push @olinks, "editlists.cgi";
}
if ($dg_version ge "2.7.5") {
  push @olinks, "groups.cgi";
}
if ($avplugin_version ge "1.0") {
    push @olinks, "editavconf.cgi";
}
@otitles = map { $t=$_; $t=~s/.cgi//; "$t" } @olinks;
for($i=0; $i<@otitles; $i++) {
  if (!$access{$otitles[$i]}) {
    splice(@otitles, $i, 1);
    splice(@olinks, $i, 1);
    $i--;
  }
  else {
    $otitles[$i] = $text{'index_'.$otitles[$i]};
  }
}
@oicons =  map { $t=$_; $t=~s/cgi/gif/; $t=~s/edit//; "images/$t" } @olinks;
icons_table(\@olinks, \@otitles, \@oicons);

print "<hr>\n";
footer("/", $text{'index'});
exit;
