#!/usr/bin/perl
# saveavconf.cgi

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();

#&init_config();
#&clean_environment();

&header($text{'avsaveconf_title'}, "", "saveconf");

# Check if AntiVirus Plugin conf file is there
my $avconffilepath = "$config{'avconf_file'}";
if (!(-f $avconffilepath)) {
    print "<p>";
    print &text('error_avconfnotfound', $avconffilepath, "/config.cgi?$module_name"),"<p>\n";
    print "$text{'index_confloc'} $avconffilepath.";
    print "<hr>\n";
    &footer("/", $text{'index_return'});
    exit;
}
# Read in the virusscanner.conf file
$avcfref = read_file_lines($avconffilepath);
my $filename = $in{"avconffilepath"};
print "$text{'saveconf_configfile'} <b>$filename</b><p>\n";

if ($avplugin_version ge "1.0") {
  @configoptions = ("Quarantine Dir","Log Facility","Virus Scanner","Sweep","Virus Scanner Timeout","Local Postmaster","Action","Debug","Lock File Dir","Minimum Code Status");
  %configmappings = ("Quarantine Dir" => "avpluginquarantinedir","Log Facility" => "avpluginlogfacility","Virus Scanner" => "avpluginvirusscanner","Sweep" => "avpluginsweep","Virus Scanner Timeout" => "avpluginvirusscannertimeout","Local Postmaster" => "avpluginlocalpostmaster","Action" => "avpluginaction","Debug" => "avplugindebug","Lock File Dir" => "avpluginlockfiledir","Minimum Code Status" => "avpluginminimumcodestatus");
  if ($avplugin_version ge "1.0" && $avplugin_version !~ /1.0rc/) {
    push (@configoptions, "Download Dir","Mail Domain","Mail Server","Mail Type");
    $configmappings{"Download Dir"} = "avplugindownloaddir";
    $configmappings{"Mail Domain"} = "avpluginmaildomain";
    $configmappings{"Mail Server"} = "avpluginmailserver";
    $configmappings{"Mail Type"} = "avpluginmailtype";
  }
} else {
  @configoptions = ();
  %configmappings = ();
}

my $opt;
my $grep_count;
foreach $opt (@configoptions) {
    $grep_count = grep { s/^(\s*$opt\s*=\s*)([^#]*)(.*)$/$1$in{$configmappings{$opt}}$3/i } @{$avcfref};
    if ($grep_count eq "0") {
        push @{$avcfref}, "$opt = $in{$opt}";
    }
}
# write out the modified version of the virusscanner.conf file
&flush_file_lines();

#print "<b>$text{'avsaveconf_configdata'}</b><br>";
#print "<pre>\n";
#my $conf_line;
#foreach $conf_line (@{$avcfref}) {
#  print "$conf_line\n";
#}
#print "</pre>\n";

if ($access{'autorestart'}) {
  printf "<b>%s</b> %s<p>\n", $text{'note'}, $text{'restart_title'};
  &dgprocess("restart");
} else {
  printf "<b>%s</b> %s<p>\n", $text{'note'}, $text{'forgetrestart'};
}

&footer("index.cgi", $text{'index_return'}, "editavconf.cgi", $text{'edit_avconfig'});
