#!/usr/bin/perl
# saveconf.cgi

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();

&header($text{'saveconf_title'}, "", "saveconf");

# Make sure user is allowed to edit conf first
&checkmodauth(editconf);

# Check if DansGuardian conf file is there
&checkdgconf;

# Read in the dansguardian.conf file
$cfref = read_file_lines($conffilepath);
$filename = $in{"conffilepath"};
$configsection = $in{"configsection"};
print "$text{'saveconf_configfile'} <b>$filename</b><p>\n";

@configoptions = ();

# This is checkbox options
@cbopts = ("reverseaddresslookups", "usernameidmethodproxyauth", "usernameidmethodident", "forwardedfor", "usexforwardedfor", "reverseclientiplookups", "nodaemon", "nologger", "softrestart", "logexceptionhits", "showweightedfound", "logconnectionhandlingerrors", "preservecase", "hexdecodecontent", "forcequicksearch", "nonstandarddelimiter", "preemptivebanning", "createlistcachefiles", "virusscan");

# This is textbox options
@tbopts= ("accessdeniedaddress", "languagedir", "language", "ipcfilename", "urlipcfilename", "pidfilename", "daemonuser", "daemongroup", "filtergroupslist", "htmltemplate", "exceptionvirusmimetypelist", "exceptionvirusextensionlist", "banneduserlist", "bannediplist", "exceptionuserlist", "exceptioniplist", "contentregexplist", "languagefile", "bannedphraselist", "bannedextensionlist", "bannedmimetypelist", "bannedsitelist", "bannedurllist", "bannedregexpurllist", "exceptionphraselist", "exceptionurllist", "weightedphraselist", "picsfile");

# This sets the default config options for ALL DG versions
# Version specific ones are push-ed into the array
#

## Network
if ($configsection eq "network") {
  push(@configoptions, "filterip","filterport","proxyport","proxyip","reverseaddresslookups", "usernameidmethodproxyauth", "usernameidmethodident", "forwardedfor");
  if ($dg_version ge "2.4.6") { push(@configoptions, "usexforwardedfor"); }
  if ($dg_version ge "2.7.5") { push(@configoptions, "reverseclientiplookups"); }

## Process
} elsif ($configsection eq "process") {
  push(@configoptions, "maxchildren");
  if ($dg_version ge "2.7.0") {
    push(@configoptions, "minchildren", "minsparechildren", "preforkchildren", "maxsparechildren", "maxagechildren");
  }
  if ($dg_version ge "2.7.2") {
    push (@configoptions, "ipcfilename", "urlipcfilename", "nodaemon", "nologger", "softrestart");
  }

## Logging
} elsif ($configsection eq "logging") {
  push(@configoptions, "logexceptionhits", "showweightedfound", "reportinglevel", "logconnectionhandlingerrors");
  if ($dg_version ge "2.4.2") { push(@configoptions, "loglevel"); }

  if ($dg_version ge "2.5.3") {
    push(@configoptions, "logfileformat", "urlcachenumber", "urlcacheage", "maxcontentfiltersize");
  }

## Content
} elsif ($configsection eq "content") {
  push(@configoptions, "banneduserlist", "bannediplist", "exceptionuserlist", "exceptioniplist", "maxuploadsize");

  if ($dg_version ge "2.4.3") {
    push(@configoptions, "weightedphrasemode");
  }
  if ($dg_version ge "2.5.3") {
    push(@configoptions, "urlcachenumber", "urlcacheage", "maxcontentfiltersize");
  }
  if (($dg_version ge "2.5.3") && ($dg_version lt "2.7.5")) {
    push(@configoptions, "contentregexplist"); 
  }
  if ($dg_version ge "2.7.0") {
    push(@configoptions, "phrasefiltermode", "preservecase", "hexdecodecontent", "forcequicksearch");
  }
  if ($dg_version lt "2.7.5") {
    push(@configoptions, "bannedphraselist", "bannedextensionlist", "bannedmimetypelist", "bannedsitelist", "bannedurllist", "bannedregexpurllist", "exceptionphraselist", "exceptionsitelist", "exceptionurllist", "weightedphraselist", "picsfile", "naughtynesslimit");
  }
  if ($dg_version ge "2.7.5") {
    push(@configoptions, "nonstandarddelimiter", "preemptivebanning", "filtergroups", "filtergroupslist");
  }

## Misc
} elsif ($configsection eq "misc") {
  push(@configoptions, "createlistcachefiles", "accessdeniedaddress");
  if ($dg_version lt "2.7.0") {
    push(@configoptions, "htmltemplate");
  }

  if (($dg_version ge "2.5.3") && ($dg_version lt "2.7.5")) {
    push(@configoptions, "languagefile");
  }

  if ($dg_version ge "2.7.0") {
    push(@configoptions, "languagedir", "language");
  }

## Antivirus
} elsif ($configsection eq "antivirus") {

  if (($dg_version ge "2.4.5-2") && ($avplugin_version ge "1.0")) {
    push(@configoptions, "virusscan");
    if ($avplugin_version ge "1.0" && $avplugin_version !~ /1.0rc/) {
      push (@configoptions, "exceptionvirusmimetypelist", "exceptionvirusextensionlist");
    }
  }

## End of Config sections
}

my $opt;
my $grep_count;
my $optchk;

# This disgusting hack checks the checkboxes.
# if the checkbox isn't checked, then set the value to off
foreach $optchk (@cbopts) {
  if (!$in{$optchk}) {
    $in{$optchk} = "off";
  }
}

foreach $optchk (@tbopts) {
  if ($in{$optchk}) {
    $in{$optchk} = "\'" . $in{$optchk} . "\'";
  }
}

#print "cfref values before push<p>\n";
#foreach $cfrefopt (@configoptions) {
#  print "$cfrefopt \= $in{$cfrefopt}<br>\n";
#}

foreach $opt (@configoptions) {
  $grep_count = grep { s/^(\s*$opt\s*=\s*)([^#]*)(.*)$/$1$in{$opt}$3/ } @{$cfref};
  if ($grep_count eq "0") {
        push @{$cfref}, "$opt = $in{$opt}";
  }
}

# write out the modified version of the dansguardian.conf file
&flush_file_lines($conffilepath);

#print "<hr><b>$text{'saveconf_configdata'}</b><br>";
#print "<pre>\n";
#my $conf_line;
#foreach $conf_line (@{$cfref}) {
#  print "$conf_line\n";
#}
#print "</pre>\n";

if ($access{'autorestart'}) {
  printf "<b>%s</b> %s<p>\n", $text{'note'}, $text{'restart_title'};
  &dgprocess("restart");
} else {
  printf "<b>%s</b> %s<p>\n", $text{'note'}, $text{'forgetrestart'};
}

print "<hr>\n";
&footer("index.cgi", $text{'index_return'}, "editconf.cgi", $text{'edit_dgconfig'});
